# This file was automatically generated by SWIG (http://www.swig.org).
# Version 4.0.2
#
# Do not make changes to this file unless you know what you are doing--modify
# the SWIG interface file instead.

from sys import version_info as _swig_python_version_info
if _swig_python_version_info < (2, 7, 0):
    raise RuntimeError("Python 2.7 or later required")

# Import the low-level C/C++ module
if __package__ or "." in __name__:
    from . import _esyslog
else:
    import _esyslog

try:
    import builtins as __builtin__
except ImportError:
    import __builtin__

def _swig_repr(self):
    try:
        strthis = "proxy of " + self.this.__repr__()
    except __builtin__.Exception:
        strthis = ""
    return "<%s.%s; %s >" % (self.__class__.__module__, self.__class__.__name__, strthis,)


def _swig_setattr_nondynamic_instance_variable(set):
    def set_instance_attr(self, name, value):
        if name == "thisown":
            self.this.own(value)
        elif name == "this":
            set(self, name, value)
        elif hasattr(self, name) and isinstance(getattr(type(self), name), property):
            set(self, name, value)
        else:
            raise AttributeError("You cannot add instance attributes to %s" % self)
    return set_instance_attr


def _swig_setattr_nondynamic_class_variable(set):
    def set_class_attr(cls, name, value):
        if hasattr(cls, name) and not isinstance(getattr(cls, name), property):
            set(cls, name, value)
        else:
            raise AttributeError("You cannot add class attributes to %s" % cls)
    return set_class_attr


def _swig_add_metaclass(metaclass):
    """Class decorator for adding a metaclass to a SWIG wrapped class - a slimmed down version of six.add_metaclass"""
    def wrapper(cls):
        return metaclass(cls.__name__, cls.__bases__, cls.__dict__.copy())
    return wrapper


class _SwigNonDynamicMeta(type):
    """Meta class to enforce nondynamic attributes (no new attributes) for a class"""
    __setattr__ = _swig_setattr_nondynamic_class_variable(type.__setattr__)


import weakref

class SwigPyIterator(object):
    thisown = property(lambda x: x.this.own(), lambda x, v: x.this.own(v), doc="The membership flag")

    def __init__(self, *args, **kwargs):
        raise AttributeError("No constructor defined - class is abstract")
    __repr__ = _swig_repr
    __swig_destroy__ = _esyslog.delete_SwigPyIterator

    def value(self):
        return _esyslog.SwigPyIterator_value(self)

    def incr(self, n=1):
        return _esyslog.SwigPyIterator_incr(self, n)

    def decr(self, n=1):
        return _esyslog.SwigPyIterator_decr(self, n)

    def distance(self, x):
        return _esyslog.SwigPyIterator_distance(self, x)

    def equal(self, x):
        return _esyslog.SwigPyIterator_equal(self, x)

    def copy(self):
        return _esyslog.SwigPyIterator_copy(self)

    def next(self):
        return _esyslog.SwigPyIterator_next(self)

    def __next__(self):
        return _esyslog.SwigPyIterator___next__(self)

    def previous(self):
        return _esyslog.SwigPyIterator_previous(self)

    def advance(self, n):
        return _esyslog.SwigPyIterator_advance(self, n)

    def __eq__(self, x):
        return _esyslog.SwigPyIterator___eq__(self, x)

    def __ne__(self, x):
        return _esyslog.SwigPyIterator___ne__(self, x)

    def __iadd__(self, n):
        return _esyslog.SwigPyIterator___iadd__(self, n)

    def __isub__(self, n):
        return _esyslog.SwigPyIterator___isub__(self, n)

    def __add__(self, n):
        return _esyslog.SwigPyIterator___add__(self, n)

    def __sub__(self, *args):
        return _esyslog.SwigPyIterator___sub__(self, *args)
    def __iter__(self):
        return self

# Register SwigPyIterator in _esyslog:
_esyslog.SwigPyIterator_swigregister(SwigPyIterator)

SHARED_PTR_DISOWN = _esyslog.SHARED_PTR_DISOWN
ESYSLOG_MAJOR_VERSION = _esyslog.ESYSLOG_MAJOR_VERSION
ESYSLOG_MINOR_VERSION = _esyslog.ESYSLOG_MINOR_VERSION
ESYSLOG_RELEASE_NUMBER = _esyslog.ESYSLOG_RELEASE_NUMBER
ESYSLOG_VERSION_STRING = _esyslog.ESYSLOG_VERSION_STRING
ESYSLOG_VERSION_NUM_DOT_STRING = _esyslog.ESYSLOG_VERSION_NUM_DOT_STRING
ESYSLOG_VERSION_NUM_STRING = _esyslog.ESYSLOG_VERSION_NUM_STRING
ESYSLOG_VERSION_NUMBER = _esyslog.ESYSLOG_VERSION_NUMBER
ESYSLOG_BETA_NUMBER = _esyslog.ESYSLOG_BETA_NUMBER
ESYSLOG_VERSION_FLOAT = _esyslog.ESYSLOG_VERSION_FLOAT
CRITICAL = _esyslog.CRITICAL
ERROR = _esyslog.ERROR
WARN = _esyslog.WARN
INFO = _esyslog.INFO
DEBUG = _esyslog.DEBUG
TRACE = _esyslog.TRACE
NOT_SET = _esyslog.NOT_SET
SPDLOG = _esyslog.SPDLOG
class Logger_if(object):
    thisown = property(lambda x: x.this.own(), lambda x, v: x.this.own(v), doc="The membership flag")

    def __init__(self, *args, **kwargs):
        raise AttributeError("No constructor defined - class is abstract")
    __repr__ = _swig_repr
    __swig_destroy__ = _esyslog.delete_Logger_if

    def log(self, *args):
        return _esyslog.Logger_if_log(self, *args)

    def lock_console(self):
        return _esyslog.Logger_if_lock_console(self)

    def unlock_console(self):
        return _esyslog.Logger_if_unlock_console(self)

# Register Logger_if in _esyslog:
_esyslog.Logger_if_swigregister(Logger_if)

class LoggerBase(Logger_if):
    thisown = property(lambda x: x.this.own(), lambda x, v: x.this.own(v), doc="The membership flag")

    def __init__(self, *args, **kwargs):
        raise AttributeError("No constructor defined - class is abstract")
    __repr__ = _swig_repr
    __swig_destroy__ = _esyslog.delete_LoggerBase

    def get_type(self):
        return _esyslog.LoggerBase_get_type(self)

    def set_name(self, name):
        return _esyslog.LoggerBase_set_name(self, name)

    def get_name(self):
        return _esyslog.LoggerBase_get_name(self)

    def add_console(self, *args):
        return _esyslog.LoggerBase_add_console(self, *args)

    def add_basic_file(self, *args):
        return _esyslog.LoggerBase_add_basic_file(self, *args)

    def add_rotating_file(self, *args):
        return _esyslog.LoggerBase_add_rotating_file(self, *args)

    def debug(self, level, msg):
        return _esyslog.LoggerBase_debug(self, level, msg)

    def set_log_level(self, log_level):
        return _esyslog.LoggerBase_set_log_level(self, log_level)

    def get_log_level(self):
        return _esyslog.LoggerBase_get_log_level(self)

    def set_flush_log_level(self, log_level):
        return _esyslog.LoggerBase_set_flush_log_level(self, log_level)

    def get_flush_log_level(self):
        return _esyslog.LoggerBase_get_flush_log_level(self)

    def set_flush_every(self, flush_every_secs):
        return _esyslog.LoggerBase_set_flush_every(self, flush_every_secs)

    def get_flush_every(self):
        return _esyslog.LoggerBase_get_flush_every(self)

    def set_debug_level(self, debug_level):
        return _esyslog.LoggerBase_set_debug_level(self, debug_level)

    def get_debug_level(self):
        return _esyslog.LoggerBase_get_debug_level(self)

# Register LoggerBase in _esyslog:
_esyslog.LoggerBase_swigregister(LoggerBase)

class User(Logger_if):
    thisown = property(lambda x: x.this.own(), lambda x, v: x.this.own(v), doc="The membership flag")
    __repr__ = _swig_repr

    def __init__(self):
        _esyslog.User_swiginit(self, _esyslog.new_User())
    __swig_destroy__ = _esyslog.delete_User

    def trace(self, msg):
        return _esyslog.User_trace(self, msg)

    def debug(self, level, msg):
        return _esyslog.User_debug(self, level, msg)

    def info(self, msg):
        return _esyslog.User_info(self, msg)

    def warn(self, msg):
        return _esyslog.User_warn(self, msg)

    def critical(self, msg):
        return _esyslog.User_critical(self, msg)

    def log(self, *args):
        return _esyslog.User_log(self, *args)

    def lock_console(self):
        return _esyslog.User_lock_console(self)

    def unlock_console(self):
        return _esyslog.User_unlock_console(self)

    def error(self, *args):
        return _esyslog.User_error(self, *args)

    def set_logger_if(self, logger_if):
        return _esyslog.User_set_logger_if(self, logger_if)

    def get_logger_if(self):
        return _esyslog.User_get_logger_if(self)

# Register User in _esyslog:
_esyslog.User_swigregister(User)

class Mngr(object):
    thisown = property(lambda x: x.this.own(), lambda x, v: x.this.own(v), doc="The membership flag")

    def __init__(self, *args, **kwargs):
        raise AttributeError("No constructor defined")
    __repr__ = _swig_repr
    __swig_destroy__ = _esyslog.delete_Mngr

    def new_default_logger(self, *args):
        return _esyslog.Mngr_new_default_logger(self, *args)

    def new_logger(self, *args):
        return _esyslog.Mngr_new_logger(self, *args)

    def set_search_folder(self, search_folder):
        return _esyslog.Mngr_set_search_folder(self, search_folder)

    def get_search_folder(self):
        return _esyslog.Mngr_get_search_folder(self)

    def find_plugin_folder(self, plugin_folder):
        return _esyslog.Mngr_find_plugin_folder(self, plugin_folder)

    @staticmethod
    def get():
        return _esyslog.Mngr_get()

# Register Mngr in _esyslog:
_esyslog.Mngr_swigregister(Mngr)

def Mngr_get():
    return _esyslog.Mngr_get()

PYESYSLOG_MAJOR_VERSION = _esyslog.PYESYSLOG_MAJOR_VERSION
PYESYSLOG_MINOR_VERSION = _esyslog.PYESYSLOG_MINOR_VERSION
PYESYSLOG_RELEASE_NUMBER = _esyslog.PYESYSLOG_RELEASE_NUMBER
PYESYSLOG_VERSION_STRING = _esyslog.PYESYSLOG_VERSION_STRING
PYESYSLOG_VERSION_NUM_DOT_STRING = _esyslog.PYESYSLOG_VERSION_NUM_DOT_STRING
PYESYSLOG_VERSION_NUM_STRING = _esyslog.PYESYSLOG_VERSION_NUM_STRING
PYESYSLOG_VERSION_NUMBER = _esyslog.PYESYSLOG_VERSION_NUMBER
PYESYSLOG_BETA_NUMBER = _esyslog.PYESYSLOG_BETA_NUMBER
PYESYSLOG_VERSION_FLOAT = _esyslog.PYESYSLOG_VERSION_FLOAT


